Attribute VB_Name = "Telnet"
'*********************************************************************************************
'                                    Nemesis Telnet Client 32 Bits
'                                       V 3.3 (BUILD 3XY)
'
' Copyright (c) 2000-2002 Jose Antonio Coret Barneto
'
'   Nemesis Telnet Client 32 Bits - The Free Telnet Client, a part of the Nemesis Project
'
'    This program is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program; if not, write to the Free Software
'    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
'
'    Redistributions of source code with or without modifications must retain the
'    above copyright notice, this list of conditions and the following disclaimer.
'
'--------------------------------------------------------------------------------------------
'IMPORTANT NOTICE:
'
'This is an unofficial translation of the GNU General Public License
'into Spanish. It was not published by the Free Software
'Foundation, and does not legally state the distribution terms for
'software that uses the GNU GPL--only the original English text of
'the GNU GPL does that. However, we hope that this translation will
'help Spanish speakers understand the GNU GPL better.
'--------------------------------------------------------------------------------------------
'
'   Este programa es software libre. Puede redistribuirlo y/o modificarlo
'   bajo los trminos de la Licencia Pblica General de GNU segn es
'   publicada por la Free Software Foundation, bien de la versin 2 de
'   dicha Licencia o bien de cualquier versin posterior.
'
'   Este programa se distribuye con la esperanza de que sea til, pero SIN
'   NINGUNA GARANTA, incluso sin la garanta MERCANTIL implcita o sin
'   garantizar la CONVENIENCIA PARA UN PROPSITO PARTICULAR. Vase la
'   Licencia Pblica General de GNU para ms detalles.
'
'   Debera haber recibido una copia de la Licencia Pblica General junto
'   con este programa. Si no ha sido as, escriba a la Free Software
'   Foundation, Inc., en 675 Mass Ave, Cambridge, MA 02139, EEUU.
'   Aada tambin informacin sobre cmo contactar con usted mediante
'   correo electrnico y postal.
'
'*********************************************************************************************
'
'PREVIOUS AUTHOR COPYRIGHT :
'
'******************************************************************************
' Parts of this code written by Ian Storrs.
' Latest updates stored at http://storrs.home.ml.org/video/telnet.zip
' Please report any bugs or suggested improvements to
' storrs@bellsouth.net
'
' Code released to public domain as is with warranty or any liabilty for
' any consequences direct or indirect of any kind whatsover.
' Use at your own risk !!!
'******************************************************************************

Option Explicit

Public Enum States
 FSM_iac_init = 1
 FSM_iac_first = 2
 FSM_iac_do = 3
 FSM_iac_dont = 4
 FSM_iac_will = 5
 FSM_iac_wont = 6
 FSM_iac_sb = 7
 FSM_terminal = 8
End Enum

Private Const SUSP = 237
Private Const ABORT = 238      'Abort
Private Const SE = 240         'End of Subnegotiation
Private Const NOP = 241
Private Const DM = 242         'Data Mark
Private Const BREAK = 243      'BREAK
Private Const IP = 244         'Interrupt Process
Private Const AO = 245         'Abort Output
Private Const AYT = 246        'Are you there
Private Const EC = 247         'Erase character
Private Const EL = 248         'Erase Line
Private Const GOAHEAD = 249    'Go Ahead
Private Const SB = 250         'What follows is subnegotiation
Private Const WILLTEL = 251
Private Const WONTTEL = 252
Private Const DOTEL = 253
Private Const DONTTEL = 254
Private Const IAC = 255

Private Const Telnet_IS = 0
Private Const Telnet_SEND = 1

Private Const BINARY = 0
Private Const ECHO = 1
Private Const RECONNECT = 2
Private Const SGA = 3
Private Const AMSN = 4
Private Const STATUS = 5
Private Const TIMING = 6
Private Const RCTAN = 7
Private Const OLW = 8
Private Const OPS = 9
Private Const OCRD = 10
Private Const OHTS = 11
Private Const OHTD = 12
Private Const OFFD = 13
Private Const OVTS = 14
Private Const OVTD = 15
Private Const OLFD = 16
Private Const XASCII = 17
Private Const LOGOUT = 18
Private Const BYTEM = 19
Private Const DET = 20
Private Const SUPDUP = 21
Private Const SUPDUPOUT = 22
Private Const SENDLOC = 23
Private Const TERMTYPE = 24
Private Const EOR = 25
Private Const TACACSUID = 26
Private Const OUTPUTMARK = 27
Private Const TERMLOCNUM = 28
Private Const REGIME3270 = 29
Private Const X3PAD = 30
Private Const NAWS = 31
Private Const TERMSPEED = 32
Private Const TFLOWCNTRL = 33
Private Const LINEMODE = 34
Private Const DISPLOC = 35
Private Const ENVIRON = 36
Private Const AUTHENTICATION = 37
Private Const ENVIRONMENT = 39
Private Const CHARSET = 42
Private Const EXTENDED_OPTIONS_LIST = 255
Private Const RANDOM_LOSE = 256




'------------------------------------------------------------

'Telnet Variables
Public Telnet_TraceOn       As Boolean
Private Telnet_Socket        As Winsock
Private Telnet_State         As States
Private Telnet_Timer         As Long
Private Telnet_SubState      As Boolean
Private Telnet_SB_Data(10)   As Integer
Private Telnet_SB_Index      As Integer
Private Telnet_sw_ugoahead   As Boolean
Private Telnet_sw_igoahead   As Boolean
Private Telnet_sw_echo       As Boolean
Private Telnet_sw_linemode   As Boolean
Private Telnet_sw_termsent   As Boolean

Private Function iac_first(CH As Byte) As Integer

  ' frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  "IAC : "

  Select Case CH
    Case DOTEL
      iac_first = FSM_iac_do
    Case DONTTEL
      iac_first = FSM_iac_dont
    Case WILLTEL
      iac_first = FSM_iac_will
    Case WONTTEL
      iac_first = FSM_iac_wont
    Case SB
      iac_first = FSM_iac_sb
      Telnet_SB_Index = 0
    Case SE
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   NEGOCIACIN FINALIZADA "
      iac_first = FSM_terminal
    Case EOR
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "EOR"
      iac_first = FSM_terminal
    Case IAC
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "IACIAC"
      iac_first = FSM_terminal
    Case Else
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "ERROR en Estado IAC " & CH
      iac_first = FSM_terminal
  End Select

End Function

Private Function iac_do(CH As Byte) As Integer

  'DO Processing Respond with WILL or WONT

  iac_do = FSM_terminal

  Select Case CH
    Case SE
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   NEGOCIACIN FINALIZADA  "
      frmTelnet.stbStatusBar.Panels(4).Text = "Negociacin Terminada " & Timer - Telnet_Timer
 
    Case BINARY
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO DO : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "BINARY"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(BINARY)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT BINARY"
    Case ECHO
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ECHO"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(ECHO)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT ECHO"
    Case NAWS
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "WINDOW SIZE"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(SB) & Chr$(NAWS) & Chr$(0) & Chr$(CharsPerLine) & Chr$(0) & Chr$(LinesPerPage) & Chr$(IAC) & Chr$(SE)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: SB WINDOW SIZE 80x24"
    Case SGA
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "SGA"
        If Not Telnet_sw_igoahead Then
            If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WILL SGA"
            Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(SGA)
            Telnet_sw_igoahead = True
        End If
    Case TERMTYPE
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TERMTYPE"
         If Not Telnet_sw_termsent Then
            If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WILL TERMTYPE"
              Telnet_sw_termsent = True
              Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(TERMTYPE)
            If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: SB TERMTYPE VT100"
              Telnet_Socket.SendData Chr$(IAC) & Chr$(SB) & Chr$(TERMTYPE) & _
              Chr$(0) & "VT100" & Chr$(IAC) & Chr$(SE)
         End If
 
    Case TERMSPEED
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TERMSPEED"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WILL TERMSPEED"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(TERMSPEED)
      
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: SB TERMSPEED 57600"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(SB) & Chr$(TERMSPEED) & Chr$(0)
        Telnet_Socket.SendData "57600,57600"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(SE)
      
    Case TFLOWCNTRL
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "FLOWCNONTROL"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT FLOWCONTROL"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case LINEMODE
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "LINEMODE"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT LINEMODE"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case STATUS
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "STATUS"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT STATUS"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case TIMING
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TIMING"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT TIMING"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case DISPLOC
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER :"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "DISPLOC"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT DISPLOC"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
    
    Case ENVIRON
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER :"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "OLDENVIRON"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT OLDENVIRON"
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
    
    Case ENVIRONMENT
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRONMENT"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT ENVIRONMENT "
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)

    Case AUTHENTICATION
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "AUTHENTICATION"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WILL AUTHENTICATION """
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(CH)
      
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: SB AUTHENTICATION"
        Telnet_Socket.SendData Chr$(IAC) & _
                          Chr$(SB) & _
                          Chr$(AUTHENTICATION) & _
                          Chr$(0) & Chr$(0) & Chr$(0) & Chr$(0) & _
                          Chr$(IAC) & _
                          Chr$(SE)
    Case Else
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "RECIBIDO HACER : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "UNKNOWN CMD " & Asc(CH)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT UNKNOWN CMD " & CH
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
  End Select

End Function
Private Function iac_dont(CH As Byte) As Integer

  'DONT Processing

 
  iac_dont = FSM_terminal
        

  Select Case CH
    Case SE
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   NEGOCIACIN FINALIZADA "
      frmTelnet.stbStatusBar.Panels(4).Text = "Negociacin Finalizada  " & Timer - Telnet_Timer

    Case ECHO
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ECHO"
      If Not Telnet_sw_echo Then
        Telnet_sw_echo = True
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(ECHO)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT ECHO"
      End If
    Case SGA
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "SGA"
      If Not Telnet_sw_ugoahead Then
        Telnet_sw_ugoahead = True
        Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(SGA)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT SGA"
      End If
    
    Case TERMSPEED
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TERMSPEED"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT TERMSPEED"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case TFLOWCNTRL
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "FLOWCONTROL"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT FLOWCONTROL"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case LINEMODE
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "LINEMODE"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT LINEMODE"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case STATUS
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "STATUS"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT STATUS"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case TIMING
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TIMING"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT TIMING"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
      
    Case DISPLOC
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "DISPLOC"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT DISPLOC"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
    
    Case ENVIRON
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRON"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT ENVIRON"
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
    
    Case ENVIRONMENT
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRONMENT"
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT " & Asc(CH)
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
        
    Case Else
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED DONT : "
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "UNKNOWN CMD " & Asc(CH)
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   ENVIAR: WONT UNKNOWN CMD " & Asc(CH)
      Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
  End Select

End Function


Private Function iac_will(CH As Byte) As Integer

  ' WILL Processing - Respond with DO or DONT
  

  iac_will = FSM_terminal

  Select Case CH
    Case SE
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   NEGOTIATION ENDED "
        frmTelnet.stbStatusBar.Panels(4).Text = "Negociacin Finalizada " & Timer - Telnet_Timer
    
    Case ECHO
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ECHO"
          If Not Telnet_sw_echo Then
            Telnet_sw_echo = True
            Telnet_Socket.SendData Chr$(IAC) & Chr$(DOTEL) & Chr$(ECHO)
          If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DO ECHO"
          End If
    
    Case SGA
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "SGA"
          If Not Telnet_sw_ugoahead Then
            Telnet_sw_ugoahead = True
            Telnet_Socket.SendData Chr$(IAC) & Chr$(DOTEL) & Chr$(SGA)
          If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DOTEL SGA"
          End If
    
    Case TERMSPEED
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TERMSPEED"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT TERMSPEED"
          Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case TFLOWCNTRL
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TFLOWCNTRL"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT FLOWCONTROL"
          Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case LINEMODE
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "LINEMODE"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT LINEMODE"
          Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case STATUS
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "STATUS"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT STATUS"
          Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case TIMING
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TIMING"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT TIMING"
          Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case DISPLOC
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "DISPLOC"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT DISPLOC"
          Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case ENVIRON
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRON"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT ENVIRON"
         Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case ENVIRONMENT
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRONMENT"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT ENVIRONMENT"
         Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case Else
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WILL : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "UNKNOWN CMD " & Asc(CH)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT UNKNOWN CMD " & Asc(CH)
         Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
  End Select

End Function

Private Function iac_wont(CH As Byte) As Integer

  ' WONT Processing
  

  iac_wont = FSM_terminal

  Select Case CH
    Case SE
      If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   NEGOTIATION ENDED "
      frmTelnet.stbStatusBar.Panels(4).Text = "Negociacin Finalizada " & Timer - Telnet_Timer
    
    Case ECHO
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ECHO"
          If Telnet_sw_echo = True Then
           ' Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(ECHO)
           ' If Telnet_TraceOn Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  Int(Timer) & "   SENT: DONTEL ECHO"
            Telnet_sw_echo = False
          End If
      
    Case SGA
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "SGA"
    '    If Telnet_TraceOn Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  Int(Timer) & "   SENT: DONT SGA"
    '      Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(SGA)
          Telnet_sw_igoahead = False
    
    Case TERMSPEED
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TERMSPEED"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT TERMSPEED"
     '     Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case TFLOWCNTRL
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "FLOWCONTROL"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT FLOWCONTROL"
        '  Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case LINEMODE
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "LINEMODE"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT LINEMODE"
        '  Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case STATUS
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "STATUS"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT STATUS"
        '  Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case TIMING
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "TIMING"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT TIMING"
     '     Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
      
    Case DISPLOC
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "DISPLOC"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT DISPLOC"
      '    Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case ENVIRON
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRON"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT ENVIRON"
      '    Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case ENVIRONMENT
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "ENVIRONMENT"
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT " & Asc(CH)
      '    Telnet_Socket.SendData Chr$(IAC) & Chr$(DONTTEL) & Chr$(CH)
    
    Case Else
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED WONT : "
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "UNKNOWN CMD " & Asc(CH)
        If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DONT UNKNOWN CMD " & Asc(CH)
      '  Telnet_Socket.SendData Chr$(IAC) & Chr$(WONTTEL) & Chr$(CH)
  End Select

End Function

Private Function iac_sb(CH As Byte) As Integer

  ' Collect parms after SB and until another IAC

    Select Case CH
        Case IAC
            iac_sb = FSM_iac_sb
        
        Case SE
          ' End of negotiation string, string is in Telnet_SB_Data()
          iac_sb = FSM_terminal
          If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED : SE "
          Select Case Telnet_SB_Data(0)
            Case TERMTYPE
              If Telnet_SB_Data(1) = Telnet_SEND Then
                    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: SB TERMTYPE VT100"
                    Telnet_Socket.SendData Chr$(IAC) & Chr$(SB) & Chr$(TERMTYPE) & "VT100" & Chr$(0) & Chr$(IAC) & Chr$(SE)
              End If
            Case TERMSPEED
              If Telnet_SB_Data(1) = Telnet_SEND Then
                    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: SB TERMSPEED 57600"
                    Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(CH)
                    Telnet_Socket.SendData Chr$(IAC) & Chr$(SB) _
                                    & Chr$(TERMSPEED) & Chr$(0) _
                                    & "57600,57600" _
                                    & Chr$(IAC) & Chr$(SE)
              End If
          End Select
        
        Case Else
            If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "                                                                   RECEIVED : "
            If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & "SB(" & Telnet_SB_Index & ") = " & CH
            
            Telnet_SB_Data(Telnet_SB_Index) = CH
            Telnet_SB_Index = Telnet_SB_Index + 1
            
            iac_sb = FSM_iac_sb
    End Select
    
' old code no longer used
'    If ich = IAC Then
'      If Telnet_TraceOn Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  Int(Timer) & "SB = IAC"
'      iac_sb = FSM_iac_first
'      Exit Function
'    End If
    
'    If Telnet_TraceOn Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  Int(Timer) & "                                                                   RECEIVED : "
'    If Telnet_TraceOn Then frmPasos.txtpasos.text=frmpasos.txtpasos.text  & vbcrlf &  Int(Timer) & "SB(" Telnet_SB_Index ") = " & ich
    
'    Telnet_SB_Data(Telnet_SB_Index) = ich
'    Telnet_SB_Index = Telnet_SB_Index + 1
    
'    iac_sb = FSM_iac_sb

End Function


Public Function Telnet_Init(SocketHandle As Winsock) As String
    Set Telnet_Socket = Nothing
    Set Telnet_Socket = SocketHandle
    
    Telnet_sw_ugoahead = True
    Telnet_sw_igoahead = False
    Telnet_sw_echo = True
    Telnet_sw_linemode = False
    Telnet_sw_termsent = True
    Telnet_SubState = False
    Telnet_State = FSM_iac_init
    Telnet_Timer = Timer
    
    Telnet_Socket.SendData Chr$(IAC) & Chr$(DOTEL) & Chr$(ECHO)
    Telnet_Socket.SendData Chr$(IAC) & Chr$(DOTEL) & Chr$(SGA)
    Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(NAWS)
    Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(TERMTYPE)
    Telnet_Socket.SendData Chr$(IAC) & Chr$(WILLTEL) & Chr$(TERMSPEED)
    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DO ECHO"
    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: DO SGA"
    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: WILL NAWS"
    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: WILL TERMTYPE"
    If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "   SENT: WILL TERMSPEED"

End Function
Public Sub Telnet_ProcessChar(CH As Byte)
    Select Case Telnet_State
        Case FSM_terminal
            If CH = IAC Then
              Telnet_State = FSM_iac_first
            Else
              term_process_char CH
            End If
        Case FSM_iac_first
            Telnet_State = iac_first(CH)
        Case FSM_iac_do
            Telnet_State = iac_do(CH)
        Case FSM_iac_dont
            Telnet_State = iac_dont(CH)
        Case FSM_iac_will
            Telnet_State = iac_will(CH)
        Case FSM_iac_wont
            Telnet_State = iac_wont(CH)
        Case FSM_iac_sb
            Telnet_State = iac_sb(CH)
        Case FSM_iac_init
            If CH = IAC Then
              Telnet_State = FSM_iac_first
            Else
              term_process_char CH
            End If
        Case Else
            If Telnet_TraceOn Then frmPasos.txtpasos.Text = frmPasos.txtpasos.Text & vbCrLf & Int(Timer) & "Invalid 'next (" + Str$(Telnet_State) + ")' processing routine in Telnet_State loop"
    End Select
End Sub

